----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:53:14 05/26/2009 
-- Design Name: 
-- Module Name:    Baud_generator - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Baud_generator is
	generic( N : integer := 9; 
				M: integer := 326
			  );
	port( clk,reset: in std_logic;
			tick: out std_logic
		 );
end Baud_generator;

architecture RTL of Baud_generator is
	signal counter: std_logic_vector(8 downto 0);
	
begin  
  
    process(clk)
    begin
      if(clk'event and clk='1') then
			if reset='1' then
				counter<=(others => '0');
			elsif counter="101000110" then
				tick <='1';
				counter<=(others=>'0');
			else 
				tick <='0';
				counter<=counter +1;
			end if;
      end if;
    end process;
    
end RTL;

architecture Behavioral of Baud_generator is
	signal count: unsigned(N-1 downto 0);
	signal count_next: unsigned (N-1 downto 0);
begin  
  
    process(clk)
    begin
      if(clk'event and clk='1') then
			if reset='1' then
				count<=(others => '0');
			else
				count <=count_next;
			end if;
      end if;
    end process;
    
    count_next <= (others => '0') when count=(M-1) else
                  count + 1;
    
    tick <= '1' when count=(M - 1) else '0';
end Behavioral;



