----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:39:49 05/06/2010 
-- Design Name: 
-- Module Name:    OCUart - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity OCUart is
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           RxD : in  STD_LOGIC;
			  TxD : out  STD_LOGIC;
           read_done : out  STD_LOGIC;
           data_out : out  STD_LOGIC_VECTOR (7 downto 0));
end OCUart;

architecture Behavioral of OCUart is
  -----------------------------------------------------------------------------
  -- Signals
  -----------------------------------------------------------------------------
  signal Start     : Std_Logic := '0';      -- Syncro signal
  signal tmpRxD    : Std_Logic;             -- RxD buffer
--  signal frameErr  : Std_Logic;
  signal BitCnt    : integer range 0 to 9 := 0;
  signal SampleCnt : integer range 0 to 15;			-- samples on one bit counter
  signal ShtReg    : Std_Logic_Vector(7 downto 0);
  
  signal BitClk : std_logic := '0';
begin

TxD <= '1';	-- !start bit

process (clk)
	constant diver : integer := 50000000 / (16 * 9600) - 1;
	variable brojac : integer range 0 to diver := 0;
begin
	if (rising_edge(clk)) then
		BitClk <= '0';
		if (brojac = diver) then
			brojac := 0;
			BitClk <= '1';
		else
			brojac := brojac + 1;
		end if;
	end if;
end process;

---------------------------------------------------------------------
-- Receiver process
---------------------------------------------------------------------
RcvProc : process(Clk, Reset)
begin
	if Reset = '1' then
		BitCnt <= 0;
		Start <= '0';
--		frameErr <= '0';

		ShtReg <= "00000000";  --
	elsif Rising_Edge(Clk) then
		read_done <= '0';

		if BitClk = '1' then
			if Start = '0' then
				if RxD = '0' then -- Start bit, 
					SampleCnt <= 1;
					Start <= '1';
				end if;
			else
				SampleCnt <= SampleCnt + 1;
				
				if SampleCnt = 8 then  -- reads the RxD line
					tmpRxD <= RxD;            
				elsif SampleCnt = 15 then
					case BitCnt is
						when 0 =>
							if tmpRxD = '1' then -- Start Bit
								Start <= '0';
							else
								BitCnt <= BitCnt + 1;
							end if;
						when 1|2|3|4|5|6|7|8 =>
							BitCnt <= BitCnt + 1;
							ShtReg <= tmpRxD & ShtReg(7 downto 1);
						when 9 =>
--							if tmpRxD = '0' then  -- stop bit expected
--								frameErr <= '1';
--							else
--								frameErr <= '0';
--							end if;

							BitCnt <= 0;
							Start <= '0';
							read_done <= '1';
							
						when others =>
							null;
					end case;
				end if;
			end if;
		end if;
	end if;
end process;

data_out <= ShtReg;

end Behavioral;
