----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    00:09:32 05/29/2009 
-- Design Name: 
-- Module Name:    Uart_driver - Structural 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Uart_driver is
	port(
			RX: in STD_LOGIC;
			TX: out STD_LOGIC;
			parity: out STD_LOGIC;
			clk: in STD_LOGIC;
			reset: in STD_LOGIC;
			Wdata_in: in STD_LOGIC_VECTOR(6 downto 0);
			Rdata_out: out STD_LOGIC_VECTOR(6 downto 0);
			write_start:in STD_LOGIC;
			read_done:out STD_LOGIC
		 );
end Uart_driver;

architecture Structural of Uart_driver is
	
	component uart_tx is
		port(
			clk: in std_logic;
			reset: in std_logic;
			tx_start: in std_logic;
			s_tick: in std_logic;
			din: in std_logic_vector (7 downto 0);
			tx_done_tick: out std_logic;
			tx: out std_logic
			);
	end component;
	
	component Baud_generator is
		port(
			clk,reset: in std_logic;
			tick: out std_logic
			);
	end component;
	
	signal tick_sig: std_logic;
	signal data_in: std_logic_vector(7 downto 0);
	signal data_out: std_logic_vector(7 downto 0);
	
	
begin
	receiver: entity work.uart_rx port map ( clk=>clk,
														reset=>reset,
														rx=>RX,
														s_tick=>tick_sig,
														dout=>data_out,
														rx_done_tick=> read_done
														);
	
	transmitter: component uart_tx port map(	clk=>clk,
															reset=>reset,
															tx_start=>write_start,
															s_tick=>tick_sig,
															din=>data_in,
															tx=>TX,
															tx_done_tick=> open
														);
	
	baudgen: component Baud_generator port map( 	clk=>clk,
																reset=>reset,
																tick=>tick_sig
															);
	--umjesto ove linije ide add_parity komponenta
	parity_gen:entity work.parity(Dataflow) port map(datain=>Wdata_in, dataout=>data_in);
	
	Rdata_out<=data_out(6 downto 0);
	parity<=data_out(7);
	
	
														

end Structural;

