----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:02:03 04/25/2010 
-- Design Name: 
-- Module Name:    pds - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ascii_decoder is	
    generic(
        W: integer := 320);
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           d_in : in  STD_LOGIC_VECTOR (6 downto 0);
           rx_done : in  STD_LOGIC;
           d_out : out  integer range 0 to W-1; 	
           d_got : out  STD_LOGIC;
           newline : out  STD_LOGIC;
			  clear : out  STD_LOGIC;
			  color : out STD_LOGIC_VECTOR(0 downto 0));
end ascii_decoder;

architecture Behavioral of ascii_decoder is
	signal temp : integer range 0 to 320;
	signal temp1, temp2 : std_logic;
	signal tmpcolor : std_logic := '1';
begin

color <= (others => tmpcolor);

process(clk, reset, d_in, rx_done)

begin

	if reset='1' then
		d_out <= 0;	
		temp <= 0;
		temp1 <= '0';
		d_got <= '0';
		newline <= '0';
		tmpcolor <= '1';
	elsif rising_edge(clk) then
		if(temp2='1') then
			temp <= 0;
		end if;
		d_got <= '0';
		newline <= '0';
		clear <= '0';
		temp2 <= '0';
		if(rx_done='1') then
			case d_in is
				when "0110000" => temp <= temp*10+0;
				when "0110001" => temp <= temp*10+1;
				when "0110010" => temp <= temp*10+2;
				when "0110011" => temp <= temp*10+3;
				when "0110100" => temp <= temp*10+4;
				when "0110101" => temp <= temp*10+5;
				when "0110110" => temp <= temp*10+6;
				when "0110111" => temp <= temp*10+7;
				when "0111000" => temp <= temp*10+8;
				when "0111001" => temp <= temp*10+9;
				when "0101100" => d_out <= temp;				--zarez
										d_got <= '1';
										temp2 <= '1';
				when "0001010" => d_out <= temp;				--novi red
										d_got <= '1';
										temp1 <= '1';
										temp2 <= '1';
				when "1000011" => clear <= '1';
				when "1000101" => tmpcolor <= '0';
				when "1000100" => tmpcolor <= '1';
				when others => temp <= temp;
			end case;
		elsif temp1='1' then
			newline <= '1';
			temp1 <= '0';
		end if;
	end if;

end process;

end Behavioral;

