----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:04:35 05/23/2009 
-- Design Name: 
-- Module Name:    bit_mapper - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use ieee.numeric_std.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity bit_mapper is
    Generic (col_w : integer := 3);
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           vga_en : in  STD_LOGIC;
			  mem_data:in std_logic_vector(0 downto 0);
			  col_in : in STD_LOGIC_VECTOR (2 downto 0);	-- rgb
			  mem_adress:out std_logic_VECTOR(16 downto 0);
			  R : out  STD_LOGIC_VECTOR (col_w-1 downto 0);
			  G : out  STD_LOGIC_VECTOR (col_w-1 downto 0);
			  B : out  STD_LOGIC_VECTOR (col_w-1 downto 0));
end bit_mapper;

architecture Behavioral of bit_mapper is

	


	signal mem_adress_int: std_logic_VECTOR(16 downto 0);
	signal mem_data_int : std_logic_vector(0 downto 0);
	signal ponovi:std_logic;
	signal count:std_logic_vector(8 downto 0);
	signal R_int : std_logic_vector(col_w-1 downto 0);
	signal G_int : std_logic_vector(col_w-1 downto 0);
	signal B_int : std_logic_vector(col_w-1 downto 0);
begin
								
	process (clk, reset)
	 variable memData:std_logic;
	 variable dalje:std_logic;
	 variable pomak:std_logic;
	begin
		
		if (rising_edge(clk)) then
			if reset = '1' then

					dalje:='1';--zbog trajanja dohvacanja od 1 ciklusa iz memorije zapocinjemo sa 1
					mem_adress_int <= (others=>'0');
					count<="000000000";
					ponovi<='1';
					pomak:='1';

			elsif vga_en = '1' then
					pomak:='1';
					if(dalje='1')
				   then 
	
						if(count="100111111")
						--if(count="000000011")--za simuliranje						
						then 
							if(ponovi='1')
							then
							  mem_adress_int<=mem_adress_int-"00000000100111111";
							--mem_adress_int<=mem_adress_int-"00000000000000011";--za simuliranje
							else
							 mem_adress_int<=mem_adress_int+'1';
							end if;
							ponovi<=not ponovi;
							count<="000000000";
							
						else
							mem_adress_int<=mem_adress_int+'1';
							count<=count+'1';
						end if;
						end if;
						
					mem_data_int <= mem_data;

					dalje:=not dalje;
										
					if (mem_data(0) = '1') then
						case (col_in(0)) is
							when '0' => R_int <= (others=>'0');
							when '1' => R_int <= (others=>'1');
							when others => R_int <= (others=>'0');
						end case;
						
						case (col_in(1)) is
							when '0' => G_int <= (others=>'0');
							when '1' => G_int <= (others=>'1');
							when others => G_int <= (others=>'0');
						end case;
						
						case (col_in(2)) is
							when '0' => B_int <= (others=>'0');
							when '1' => B_int <= (others=>'1');
							when others => B_int <= (others=>'0');
						end case;
					else
						R_int <= (others=>'0');
						G_int <= (others=>'0');
						B_int <= (others=>'0');
					end if;					
			
			else
					R_int <= (others=>'0');
					G_int <= (others=>'0');
					B_int <= (others=>'0');
			end if;	
		end if;
		
	end process;
	 
	R <= R_int;
	G <= G_int;
	B <= B_int;
	mem_adress<=mem_adress_int;
	

end Behavioral;

