----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    02:03:37 04/27/2010 
-- Design Name: 
-- Module Name:    mem_ctrl - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mem_ctrl is
    Generic (W : integer := 320; H : integer := 240);
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           coord_en : in  STD_LOGIC;
           coord_x : in  integer range 0 to W-1;
           coord_y : in  integer range 0 to H-1;
			  color : in  STD_LOGIC_VECTOR (0 downto 0);
           mem_a : out  STD_LOGIC_VECTOR (16 downto 0);
           mem_d : out  STD_LOGIC_VECTOR (0 downto 0);
           mem_we : out  STD_LOGIC);
end mem_ctrl;

architecture Behavioral of mem_ctrl is

	constant last_addr : std_logic_vector(mem_a'RANGE) := conv_std_logic_vector(W*H, mem_a'LENGTH);

	signal mem_c_a : std_logic_vector(mem_a'RANGE);
	signal obrisano : boolean := false;

begin

obrisano <= mem_c_a = last_addr;

process (obrisano, coord_en, coord_x, coord_y, mem_c_a, color)
begin
	if (obrisano) then
		mem_we <= coord_en;
		mem_a <= conv_std_logic_vector(coord_y * 320 + coord_x, mem_a'LENGTH);
		mem_d <= color;
	else
		mem_we <= '1';
		mem_a <= mem_c_a;
		mem_d <= (others => '0');
	end if;
end process;

process (clk, reset)
begin
	if (reset = '1') then
		mem_c_a <= (others => '0');
	elsif (rising_edge(clk)) then
		if (not obrisano) then
			mem_c_a <= mem_c_a + 1;
		end if;
	end if;
end process;

end Behavioral;

