----------------------------------------------------------------------------------
-- Company: FER
-- Engineer: Tomislav
-- 
-- Create Date:    11:57:06 04/29/2010 
-- Design Name: 	 projekt#3
-- Module Name:    regs - Behavioral 
-- Project Name:   Jednostavna grafika jedinica
-- Target Devices:   Spartan 3
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity regs is
generic(
		W:integer:=320;
		H:integer:=240
		);
		
port(
		clk:		in std_logic;
		reset:	in std_logic;
		d_got:	in std_logic;
		d_in:		in integer range 0 to W-1;
		rewind:	in std_logic;
		X0:		out integer range 0 to W-1;
		Y0:		out integer range 0 to H-1;
		X1:		out integer range 0 to W-1;
		Y1: 		out integer range 0 to H-1
		);
		
		
end regs;

architecture Behavioral of regs is

begin

process(clk, reset, d_got, rewind)

	variable br: integer range 1 to 4 := 1;

begin

	if reset= '1' then
		X0 <= 0;
		Y0 <= 0;
		X1 <= 0;
		Y1 <= 0;
		br := 1;	
	elsif rising_edge(clk) then
		
		if d_got= '1' then
			case br is
				when 1 =>
					X0 <= d_in;
				when 2 =>
					Y0 <= d_in;
				when 3 =>
					X1 <= d_in;
				when 4 =>
					Y1 <= d_in;
				when others => null;
			end case;
			
			br := br+1;
		end if;
			
		if rewind='1' then
			br :=1;
		end if;
		
	end if;

end process;

end Behavioral;

