----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    01:46:07 04/27/2010 
-- Design Name: 
-- Module Name:    vga_ctrl - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity vga_ctrl is
    Generic ( col_w : integer := 3 );
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           mem_d : in  STD_LOGIC_VECTOR (0 downto 0);
           mem_a : out  STD_LOGIC_VECTOR (16 downto 0);
           color : in  STD_LOGIC_VECTOR (2 downto 0);
           vga_r : out  STD_LOGIC_VECTOR (col_w-1 downto 0);
           vga_g : out  STD_LOGIC_VECTOR (col_w-1 downto 0);
           vga_b : out  STD_LOGIC_VECTOR (col_w-1 downto 0);
           vga_hsync : out  STD_LOGIC;
           vga_vsync : out  STD_LOGIC);
end vga_ctrl;

architecture Behavioral of vga_ctrl is

	signal vgaen : STD_LOGIC;
	signal vsync_int : STD_LOGIC;
	signal maperreset : STD_LOGIC;

begin

vga_sync0: entity work.vga_sync port map(clk => clk, reset => reset,
														hsync => vga_hsync, vsync => vsync_int,
														vga_en => vgaen);
vga_vsync <= vsync_int;
maperreset <= not vsync_int;

bit_mapper0: entity work.bit_mapper generic map(col_w => col_w)
												port map(clk => clk, reset => maperreset,
															vga_en => vgaen, col_in => color,
															mem_data => mem_d, mem_adress => mem_a,
															R => vga_r, G => vga_g, B => vga_b);

end Behavioral;

